program Fire2;   {$G+} { Aus Dos 7,95,1995 Seite:166 }
uses
  Crt, Dos;
const
  Intensit=200;  { Intensitt }
var
  buf   : array[0..102, 0..159] of Integer;
  pal   : array[0..255, 0..2] of Byte;
  i     : Word;
  delta : Integer;

procedure SetPalette;
var
  i : Integer;
begin
  for i := 0 to 63 do begin
    pal[i, 0] := i;
    pal[i, 1] := 0;
    pal[i, 2] := 0;
    pal[i + 64, 0] := 63;
    pal[i + 64, 1] := i;
    pal[i + 64, 2] := 0;
    pal[i + 128, 0] := 63;
    pal[i + 128, 1] := 63;
    pal[i + 128, 2] := 0;
    pal[i + 192, 0] := 63;
    pal[i + 192, 1] := 63;
    pal[i + 192, 2] := 63;
  end;
  asm
    mov ax, Seg pal
    mov es, ax
    mov dx, offset pal
    mov ax, 1012h
    mov bx, 0000h
    mov cx, 00FFh
    int 10h
  end;
end;

procedure Interpolation; assembler;
asm
  mov cx, 16159
  mov di, offset buf
  add di, 320
  @l1:
  mov ax, ds:[di - 2]
  add ax, ds:[di]
  add ax, ds:[di + 2]
  add ax, ds:[di + 320]
  shr ax, 2
  jz @l2
  sub ax, 1
  @l2:
  mov Word ptr ds:[di - 320], ax
  add di, 2
  loop @l1
end;

procedure PurgeBuf; assembler;
asm
  mov si, offset buf
  mov ax, SegA000
  mov es, ax
  xor di, di
  mov dx, 100
  @l3:
  mov bx, 2
  @l2:
  mov cx, 160
  @l1:
  mov al, [si]
  mov ah, al
  mov es:[di], ax
  add di, 2
  add si, 2
  dec cx
  jnz @l1
  sub si, 320
  dec bx
  jnz @l2
  add si, 320
  dec dx
  jnz @l3
end;

begin
  Randomize;
  asm
    mov ax, 0013h
    int 10h
  end;
  SetPalette;
  FillChar(buf, SizeOf(buf), 0);
  repeat
    Interpolation;
    for i := 0 to 159 do begin
      if Random < 0.4 then delta := Random(2) * Intensit;
      buf[101, i] := delta;
      buf[102, i] := delta;
    end;
    PurgeBuf;
  until Keypressed;
end.
